/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160729-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of /Users/michaelwlotkowski/Downloads/DarwinDumper_3.0.4_30.09_22.16.33_MacBookPro14,2_AMI_X64_4678_Unknown_18B45d_michaelwlotkowski/ACPI Tables/AML/SSDT-7.aml, Sun Sep 30 22:16:54 2018
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000E8F (3727)
 *     Revision         0x02
 *     Checksum         0xAF
 *     OEM ID           "hack"
 *     OEM Table ID     "Properti"
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20180810 (538445840)
 */
DefinitionBlock ("", "SSDT", 2, "hack", "Properti", 0x00000000)
{
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.B0D4, DeviceObj)
    External (_SB_.PCI0.HDEF, DeviceObj)
    External (_SB_.PCI0.I2C0, DeviceObj)
    External (_SB_.PCI0.I2C1, DeviceObj)
    External (_SB_.PCI0.IGPU, DeviceObj)
    External (_SB_.PCI0.IMEI, DeviceObj)
    External (_SB_.PCI0.LPCB, DeviceObj)
    External (_SB_.PCI0.PPMC, DeviceObj)
    External (_SB_.PCI0.RP07.PXSX, DeviceObj)
    External (_SB_.PCI0.SATA, DeviceObj)
    External (_SB_.PCI0.SBUS, DeviceObj)
    External (_SB_.PCI0.XHC_, DeviceObj)

    Scope (_SB.PCI0.IGPU)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (One)
                {
                     0x03                                             /* . */
                })
            }

            Return (Package (0x10)
            {
                "model", 
                Buffer (0x16)
                {
                    "Intel HD Graphics 620"
                }, 

                "hda-gfx", 
                Buffer (0x0A)
                {
                    "onboard-1"
                }, 

                "device-id", 
                Buffer (0x04)
                {
                     0x16, 0x59, 0x00, 0x00                           /* .Y.. */
                }, 

                "framebuffer-unifiedmem", 
                Buffer (0x04)
                {
                     0x00, 0x00, 0x00, 0x80                           /* .... */
                }, 

                "framebuffer-patch-enable", 
                Unicode ("\x01"), 
                "AAPL,ig-platform-id", 
                Buffer (0x04)
                {
                     0x00, 0x00, 0x16, 0x59                           /* ...Y */
                }, 

                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "device_type", 
                Buffer (0x13)
                {
                    "Graphik Controller"
                }
            })
        }
    }

    Scope (\_SB.PCI0.RP07.PXSX)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (One)
                {
                     0x03                                             /* . */
                })
            }

            Return (Package (0x0E)
            {
                "AAPL,slot-name", 
                Buffer (0x0A)
                {
                    "M.2 key M"
                }, 

                "name", 
                Buffer (0x10)
                {
                    "AirPort Extreme"
                }, 

                "model", 
                Buffer (0x34)
                {
                    "Dell Wireless 1820A - BCM94350ZAE 802.11 ac/a/b/g/n"
                }, 

                "device_type", 
                Buffer (0x08)
                {
                    "AirPort"
                }, 

                "built-in", 
                Buffer (One)
                {
                     0x00                                             /* . */
                }, 

                "PinConfigurations", 
                Buffer (One)
                {
                     0x00                                             /* . */
                }, 

                "compatible", 
                Buffer (0x0D)
                {
                    "pci14e4,4331"
                }
            })
        }
    }

    Scope (\_SB.PCI0.HDEF)
    {
        Name (_SB.PCI0.HDEF.RMCF, Package (0x02)
        {
            "CodecCommander", 
            Package (0x08)
            {
                "Custom Commands", 
                Package (0x05)
                {
                    Package (0x00) {}, 
                    Package (0x08)
                    {
                        "Command", 
                        Buffer (0x04)
                        {
                             0x01, 0x97, 0x07, 0x25                           /* ...% */
                        }, 

                        "On Init", 
                        ">y", 
                        "On Sleep", 
                        ">n", 
                        "On Wake", 
                        ">y"
                    }, 

                    Package (0x08)
                    {
                        "Command", 
                        Buffer (0x04)
                        {
                             0x02, 0x17, 0x08, 0x83                           /* .... */
                        }, 

                        "On Init", 
                        ">y", 
                        "On Sleep", 
                        ">n", 
                        "On Wake", 
                        ">y"
                    }, 

                    Package (0x08)
                    {
                        "Command", 
                        Buffer (0x04)
                        {
                             0x02, 0x05, 0x00, 0x36                           /* ...6 */
                        }, 

                        "On Init", 
                        ">y", 
                        "On Sleep", 
                        ">n", 
                        "On Wake", 
                        ">y"
                    }, 

                    Package (0x08)
                    {
                        "Command", 
                        Buffer (0x04)
                        {
                             0x02, 0x04, 0x17, 0x37                           /* ...7 */
                        }, 

                        "On Init", 
                        ">y", 
                        "On Sleep", 
                        ">n", 
                        "On Wake", 
                        ">y"
                    }
                }, 

                "Perform Reset", 
                ">y", 
                "Send Delay", 
                0x0A, 
                "Sleep Nodes", 
                ">y"
            }
        })
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (One)
                {
                     0x03                                             /* . */
                })
            }

            Return (Package (0x0E)
            {
                "alc-layout-id", 
                Unicode ("\x03"), 
                "hda-gfx", 
                Buffer (0x0A)
                {
                    "onboard-1"
                }, 

                "model", 
                Buffer (0x1A)
                {
                    "Sunrise Point-LP HD Audio"
                }, 

                "name", 
                Buffer (0x0F)
                {
                    "Realtek ALC255"
                }, 

                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "device_type", 
                Buffer (0x16)
                {
                    "High Definition Audio"
                }, 

                "layout-id", 
                Unicode ("\x03")
            })
        }
    }

    Scope (\_SB.PCI0.XHC)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (One)
                {
                     0x03                                             /* . */
                })
            }

            Return (Package (0x16)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "model", 
                Buffer (0x14)
                {
                    "Apple Intel USB 3.0"
                }, 

                "name", 
                Buffer (0x29)
                {
                    "Sunrise Point-LP USB 3.0 xHCI Controller"
                }, 

                "subsystem-id", 
                Buffer (0x04)
                {
                     0x70, 0x72, 0x00, 0x00                           /* pr.. */
                }, 

                "subsystem-vendor-id", 
                Buffer (0x04)
                {
                     0x86, 0x80, 0x00, 0x00                           /* .... */
                }, 

                "AAPL,current-available", 
                0x0834, 
                "AAPL,current-extra", 
                0x0898, 
                "AAPL,current-extra-in-sleep", 
                0x0640, 
                "AAPL,device-internal", 
                0x02, 
                "AAPL,max-port-current-in-sleep", 
                0x0834, 
                "built-in", 
                Buffer (One)
                {
                     0x00                                             /* . */
                }
            })
        }
    }

    Scope (\_SB.PCI0.IMEI)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x06)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x18)
                {
                    "Apple Intel IMEI DRIVER"
                }, 

                "model", 
                Buffer (0x1E)
                {
                    "Sunrise Point-LP CSME HECI #1"
                }
            })
        }
    }

    Scope (\_SB.PCI0.I2C0)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x08)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x2D)
                {
                    "Sunrise Point-LP Serial IO I2C Controller #0"
                }, 

                "model", 
                Buffer (0x18)
                {
                    "Apple Intel Lpss I2C #0"
                }, 

                "device_type", 
                Buffer (0x04)
                {
                    "I2C"
                }
            })
        }
    }

    Scope (\_SB.PCI0.I2C1)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x08)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x2D)
                {
                    "Sunrise Point-LP Serial IO I2C Controller #1"
                }, 

                "model", 
                Buffer (0x18)
                {
                    "Apple Intel Lpss I2C #1"
                }, 

                "device_type", 
                Buffer (0x04)
                {
                    "I2C"
                }
            })
        }
    }

    Scope (\_SB.PCI0.LPCB)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x0A)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x20)
                {
                    "Sunrise Point-LP LPC Controller"
                }, 

                "model", 
                Buffer (0x1B)
                {
                    "Apple Intel LPC Controller"
                }, 

                "device_type", 
                Buffer (0x04)
                {
                    "LPC"
                }, 

                "compatible", 
                Buffer (0x0D)
                {
                    "pci8086,9cc1"
                }
            })
        }
    }

    Scope (\_SB.PCI0.PPMC)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x08)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x15)
                {
                    "Sunrise Point-LP PMC"
                }, 

                "model", 
                Buffer (0x1A)
                {
                    "Apple Intel PCHPMC (PPMC)"
                }, 

                "device_type", 
                Buffer (0x04)
                {
                    "PMC"
                }
            })
        }
    }

    Scope (\_SB.PCI0.SBUS)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x08)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x17)
                {
                    "Sunrise Point-LP SMBus"
                }, 

                "model", 
                Buffer (0x12)
                {
                    "Apple Intel SMBUS"
                }, 

                "device_type", 
                Buffer (0x06)
                {
                    "SMBus"
                }
            })
        }

        Device (BUS0)
        {
            Name (_CID, "smbus")  // _CID: Compatible ID
            Name (_ADR, Zero)  // _ADR: Address
            Device (DVL0)
            {
                Name (_ADR, 0x57)  // _ADR: Address
                Name (_CID, "diagsvault")  // _CID: Compatible ID
                Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                {
                    Local0 = Package (0x02)
                        {
                            "address", 
                            0x57
                        }
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB.PCI0.SATA)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x08)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x2D)
                {
                    "Sunrise Point-LP SATA Controller [AHCI mode]"
                }, 

                "model", 
                Buffer (0x1A)
                {
                    "Apple AHCI SSD Controller"
                }, 

                "built-in", 
                Buffer (One)
                {
                     0x00                                             /* . */
                }
            })
        }
    }

    Scope (\_SB.PCI0.B0D4)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (Arg2 == Zero)
            {
                Return (Buffer (Zero) {})
            }

            Return (Package (0x0A)
            {
                "AAPL,slot-name", 
                Buffer (0x09)
                {
                    "Built In"
                }, 

                "name", 
                Buffer (0x44)
                {
                    "Xeon E3-1200 v5/E3-1500 v5/6th Gen Core Processor Thermal Subsystem"
                }, 

                "device_type", 
                Buffer (0x13)
                {
                    "Thermal-Controller"
                }, 

                "model", 
                Buffer (0x0E)
                {
                    "Intel Thermal"
                }, 

                "compatible", 
                Buffer (0x0D)
                {
                    "pci8086,9d21"
                }
            })
        }
    }

    Scope (\_SB.PCI0)
    {
        Device (THRC)
        {
            Name (_ADR, 0x00140002)  // _ADR: Address
            Name (THRC, One)
            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (Arg2 == Zero)
                {
                    Return (Buffer (Zero) {})
                }

                Return (Package (0x0C)
                {
                    "built-in", 
                    Buffer (One)
                    {
                         0x00                                             /* . */
                    }, 

                    "device_type", 
                    Buffer (0x13)
                    {
                        "Thermal-Controller"
                    }, 

                    "model", 
                    Buffer (0x0E)
                    {
                        "Intel Thermal"
                    }, 

                    "name", 
                    Buffer (0x23)
                    {
                        "Sunrise Point-LP Thermal subsystem"
                    }, 

                    "AAPL,slot-name", 
                    Buffer (0x09)
                    {
                        "Built In"
                    }, 

                    "compatible", 
                    Buffer (0x0D)
                    {
                        "pci8086,9d21"
                    }
                })
            }
        }

        Device (MCHC)
        {
            Name (_ADR, Zero)  // _ADR: Address
            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (Arg2 == Zero)
                {
                    Return (Buffer (Zero) {})
                }

                Return (Package (0x0A)
                {
                    "built-in", 
                    Buffer (One)
                    {
                         0x00                                             /* . */
                    }, 

                    "device_type", 
                    Buffer (0x0F)
                    {
                        "DRAM-Registers"
                    }, 

                    "model", 
                    Buffer (0x1B)
                    {
                        "Host Bridge/DRAM Registers"
                    }, 

                    "name", 
                    Buffer (0x42)
                    {
                        "Xeon E3-1200 v6/7th Gen Core Processor Host Bridge/DRAM Registers"
                    }, 

                    "AAPL,slot-name", 
                    Buffer (0x09)
                    {
                        "Built In"
                    }
                })
            }
        }
    }
}

